package uni.georgetown.ns.zebrafish.model;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import uni.georgetown.ns.zebrafish.ardulink.ArdulinkDriver;

@XmlRootElement(name = "action")
public class ActionModel {
	
	public static final String ARM_CLOCKWISE = ArdulinkDriver.ARM_CLOCKWISE;
	public static final String ARM_COUNTERCLOCKWISE = ArdulinkDriver.ARM_COUNTERCLOCKWISE;
	
	private int beforeLEDTurnOnDelay = 0;
	private boolean turnOnLED1 = false;
	private boolean turnOnLED2 = false;
	private boolean turnOnLED3 = false;
	private int beforeSoundDelay = 0;
	private String sound = "";
	private int beforeArmMovesDelay = 0;
	private int armMovementDegrees = 0;
	private String armDirection = ARM_CLOCKWISE;
	private int beforeFeedDelay = 0;
	private boolean feed = false;
	private int beforeLEDTurnOffDelay = 0;
	private int beforeArmReturnsDelay = 0;
	
    @XmlElement(name = "beforeLEDTurnOnDelay")
	public int getBeforeLEDTurnOnDelay() {
		return beforeLEDTurnOnDelay;
	}
	public void setBeforeLEDTurnOnDelay(int beforeLEDTurnOnDelay) {
		this.beforeLEDTurnOnDelay = beforeLEDTurnOnDelay;
	}

	@XmlElement(name = "turnOnLED1")
	public boolean isTurnOnLED1() {
		return turnOnLED1;
	}
	public void setTurnOnLED1(boolean turnOnLED) {
		this.turnOnLED1 = turnOnLED;
	}

	@XmlElement(name = "turnOnLED2")
	public boolean isTurnOnLED2() {
		return turnOnLED2;
	}
	public void setTurnOnLED2(boolean turnOnLED) {
		this.turnOnLED2 = turnOnLED;
	}

	@XmlElement(name = "turnOnLED3")
	public boolean isTurnOnLED3() {
		return turnOnLED3;
	}
	public void setTurnOnLED3(boolean turnOnLED) {
		this.turnOnLED3 = turnOnLED;
	}

	@XmlElement(name = "beforeSoundDelay")
	public int getBeforeSoundDelay() {
		return beforeSoundDelay;
	}
	public void setBeforeSoundDelay(int beforeSoundDelay) {
		this.beforeSoundDelay = beforeSoundDelay;
	}

	@XmlElement(name = "sound")
	public String getSound() {
		return sound;
	}
	public void setSound(String sound) {
		this.sound = sound;
	}

	@XmlElement(name = "beforeArmMovesDelay")
	public int getBeforeArmMovesDelay() {
		return beforeArmMovesDelay;
	}
	public void setBeforeArmMovesDelay(int beforeArmMovesDelay) {
		this.beforeArmMovesDelay = beforeArmMovesDelay;
	}

	@XmlElement(name = "armMovementDegrees")
	public int getArmMovementDegrees() {
		return armMovementDegrees;
	}
	public void setArmMovementDegrees(int armMovementDegrees) {
		this.armMovementDegrees = armMovementDegrees;
	}

	@XmlElement(name = "armDirection")
	public String getArmDirection() {
		return armDirection;
	}
	public void setArmDirection(String armDirection) {
		this.armDirection = armDirection;
	}

	@XmlElement(name = "beforeFeedDelay")
	public int getBeforeFeedDelay() {
		return beforeFeedDelay;
	}
	public void setBeforeFeedDelay(int beforeFeedDelay) {
		this.beforeFeedDelay = beforeFeedDelay;
	}

	@XmlElement(name = "feed")
	public boolean isFeed() {
		return feed;
	}
	public void setFeed(boolean feed) {
		this.feed = feed;
	}

    @XmlElement(name = "beforeLEDTurnOffDelay")
	public int getBeforeLEDTurnOffDelay() {
		return beforeLEDTurnOffDelay;
	}
	public void setBeforeLEDTurnOffDelay(int beforeLEDTurnOffDelay) {
		this.beforeLEDTurnOffDelay = beforeLEDTurnOffDelay;
	}
	
	@XmlElement(name = "beforeArmReturnsDelay")
	public int getBeforeArmReturnsDelay() {
		return beforeArmReturnsDelay;
	}
	public void setBeforeArmReturnsDelay(int beforeArmReturnsDelay) {
		this.beforeArmReturnsDelay = beforeArmReturnsDelay;
	}

	public void set(ActionModel actionModel) {
		this.beforeLEDTurnOnDelay = actionModel.beforeLEDTurnOnDelay;
		this.turnOnLED1 = actionModel.turnOnLED1;
		this.turnOnLED2 = actionModel.turnOnLED2;
		this.turnOnLED3 = actionModel.turnOnLED3;
		this.beforeSoundDelay = actionModel.beforeSoundDelay;
		this.sound = actionModel.sound;
		this.beforeArmMovesDelay = actionModel.beforeArmMovesDelay;
		this.armMovementDegrees = actionModel.armMovementDegrees;
		this.armDirection = actionModel.armDirection;
		this.beforeFeedDelay = actionModel.beforeFeedDelay;
		this.feed = actionModel.feed;
		this.beforeLEDTurnOffDelay = actionModel.beforeLEDTurnOffDelay;
		this.beforeArmReturnsDelay = actionModel.beforeArmReturnsDelay;
	}
}
