package uni.georgetown.ns.zebrafish.model;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "timer")
public class TimerModel {

	// 24:00:00 is equal to 00:00:00
	private byte hours = 0; // 0 to 24
	private byte minutes = 0; // 0 to 59
	private byte seconds = 0; // 0 to 59
	
	private static final SimpleDateFormat dateFormat = new SimpleDateFormat("HH:mm:ss");
	
    public TimerModel() {
	}

	public TimerModel(Date date) {
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(date);
		hours = (byte)calendar.get(Calendar.HOUR_OF_DAY);
		minutes = (byte)calendar.get(Calendar.MINUTE);
		seconds = (byte)calendar.get(Calendar.SECOND);
	}

    @XmlElement(name = "hours")
	public byte getHours() {
		return hours;
	}
	public void setHours(byte hours) {
		this.hours = hours;
	}
    @XmlElement(name = "minutes")
	public byte getMinutes() {
		return minutes;
	}
	public void setMinutes(byte minutes) {
		this.minutes = minutes;
	}
    @XmlElement(name = "seconds")
	public byte getSeconds() {
		return seconds;
	}
	public void setSeconds(byte seconds) {
		this.seconds = seconds;
	}

	public Date getTodayTime() {
		Calendar calendar = Calendar.getInstance();
		calendar.set(Calendar.HOUR_OF_DAY, hours);
		calendar.set(Calendar.MINUTE, minutes);
		calendar.set(Calendar.SECOND, seconds);
		calendar.set(Calendar.MILLISECOND, 0);
		
		return calendar.getTime();
	}
	
	public String getFormattedTime() {
		Date today = getTodayTime();
		return dateFormat.format(today);
	}
	
	public static void main(String[] args) {
		
		TimerModel tm = new TimerModel();
		tm.setHours((byte)13);
		tm.setMinutes((byte)23);
		tm.setSeconds((byte)26);
		
		Date todayTime = tm.getTodayTime();
		System.out.println(todayTime);
		System.out.println(tm.getFormattedTime());
	}

	public void set(TimerModel model) {
		this.hours = model.hours;
		this.minutes = model.minutes;
		this.seconds = model.seconds;
	}
}
